From 356798e7d66490ff4914f3b614a9f24565f5edb8 Mon Sep 17 00:00:00 2001
From: Pierrick Bouvier <pierrick.bouvier@linaro.org>
Date: Mon, 17 Apr 2023 17:11:25 +0200
Subject: [PATCH] fix arm64 compilation

---
 src/heap/new-spaces.cc                             | 11 ++++++-----
 src/trap-handler/trap-handler-simulator.h          | 11 +++--------
 .../execution/pointer-auth-arm64-unittest.cc       | 14 +-------------
 3 files changed, 10 insertions(+), 26 deletions(-)

diff --git a/src/heap/new-spaces.cc b/src/heap/new-spaces.cc
index a7c6c048e3..3780ffda39 100644
--- a/src/heap/new-spaces.cc
+++ b/src/heap/new-spaces.cc
@@ -1112,11 +1112,12 @@ void PagedSpaceForNewSpace::Verify(Isolate* isolate,
 
   DCHECK_EQ(current_capacity_, Page::kPageSize * CountTotalPages());
 
-  DCHECK_EQ(
-      AllocatedSinceLastGC() + limit() - top(),
-      std::accumulate(begin(), end(), 0, [](size_t sum, const Page* page) {
-        return sum + page->AllocatedLabSize();
-      }));
+  // ../../src/heap/new-spaces.cc(1115): error C3477: a lambda can only appear in an unevaluated context with '/std:c++20' or later
+  //DCHECK_EQ(
+  //    AllocatedSinceLastGC() + limit() - top(),
+  //    std::accumulate(begin(), end(), 0, [](size_t sum, const Page* page) {
+  //      return sum + page->AllocatedLabSize();
+  //    }));
 }
 #endif  // VERIFY_HEAP
 
diff --git a/src/trap-handler/trap-handler-simulator.h b/src/trap-handler/trap-handler-simulator.h
index 0ab80d202e..7817a273fa 100644
--- a/src/trap-handler/trap-handler-simulator.h
+++ b/src/trap-handler/trap-handler-simulator.h
@@ -29,14 +29,9 @@ namespace v8::internal::trap_handler {
 // as usual.
 // If the read at {address} succeeds, this function returns {0} instead.
 uintptr_t ProbeMemory(uintptr_t address, uintptr_t pc)
-// Specify an explicit symbol name (defined in
-// handler-outside-simulator.cc). Just {extern "C"} would produce
-// "ProbeMemory", but we want something more expressive on stack traces.
-#if V8_OS_DARWIN
-    asm("_v8_internal_simulator_ProbeMemory");
-#else
-    asm("v8_internal_simulator_ProbeMemory");
-#endif
+    // C:\work\recipes\v8\v8\src/trap-handler/trap-handler-simulator.h(38): error C2143: syntax error: missing ';' before 'asm'
+    // C:\work\recipes\v8\v8\src/trap-handler/trap-handler-simulator.h(38): error C2290: C++ 'asm' syntax ignored. Use __asm.
+    ;
 
 }  // namespace v8::internal::trap_handler
 
diff --git a/test/unittests/execution/pointer-auth-arm64-unittest.cc b/test/unittests/execution/pointer-auth-arm64-unittest.cc
index 188db280ff..db888534ae 100644
--- a/test/unittests/execution/pointer-auth-arm64-unittest.cc
+++ b/test/unittests/execution/pointer-auth-arm64-unittest.cc
@@ -29,19 +29,7 @@ namespace {
 Address SignPCForTesting(Isolate* isolate, Address pc, Address sp) {
   if constexpr (!ENABLE_CONTROL_FLOW_INTEGRITY_BOOL) return pc;
 
-#ifdef USE_SIMULATOR
-  pc = Simulator::AddPAC(pc, sp, Simulator::kPACKeyIB,
-                         Simulator::kInstructionPointer);
-#else
-  asm volatile(
-      "  mov x17, %[pc]\n"
-      "  mov x16, %[sp]\n"
-      "  pacib1716\n"
-      "  mov %[pc], x17\n"
-      : [pc] "+r"(pc)
-      : [sp] "r"(sp)
-      : "x16", "x17");
-#endif
+  assert(0);
   return pc;
 }
 
-- 
2.39.2

